# encoding: utf-8
# frozen_string_literal: true

COMPORT = 'COM7'
SLICE_SIZE = 256*1024

require 'tempfile'

`flexspin -2 psram_loadit.spin2`

raise "Need exactly one argument" if ARGV.size != 1


thefile = File.binread(ARGV[0])

totalslices = ((thefile.size-1)/SLICE_SIZE)+1

i = 0
until thefile.empty?
    puts "Loading slice #{i}..."
    tmp = Tempfile.new("loadit", binmode: true)
    tmp.write(i.chr)
    tmp.write(totalslices.chr)
    tmp.write(thefile.slice!(0...SLICE_SIZE).ljust(SLICE_SIZE,?\0))
    tmp.close
    `loadp2 -p #{COMPORT} @0=psram_loadit.binary,@7FFE=#{tmp.path} -e "recv(E)"`
    tmp.unlink
    i+=1
end


